---
title: 实打实的 Go 项目，但是 Github 却统计为 JavaScript 怎么办？
date: 2018-12-04T17:13:46+08:00
---
来源：『Go 夜读』微信群

时间：2018-12-04

---

## 原理

Github 采用 Linguist 来自动识别你的代码，然后判断属于哪一种语言。

## 问题

但是我是一个 Go 相关的文档或者 Go Web 工程项目，肯定希望在搜索 Go 语言的时候，也能包括我，并且显示项目所属语言为 Go。

但是默认情况下，你肯定会失望。。。可能还会吐槽：为什么 Github 不提供一个选择项目所属语言呢？

>针对这个问题，我的思考是，Github 就是想让大家 hack 一点。

## 解决方法

1. 在项目中增加更多的你所想要归属的语言的代码（综合性项目，最好是采用这种方式）。
2. 在项目中添加 `.gitattributes` 

```sh
*.js linguist-language=go
*.java linguist-language=go
...
```

这种方式会导致你处理的后缀语言也不会在项目中被标识出来了。

