---
desc: Go 夜读之对 Go 程序进行可靠的性能测试
title: 第 83 期对 Go 程序进行可靠的性能测试
date: 2020-03-26T21:00:00+08:00
author: 欧长坤
---

## 【Go 夜读】#83 对 Go 程序进行可靠的性能测试

​性能测试是 Go 语言工具链中比较重要的一环。我们已经知道了如何编写一个形如 `func BenchmarkFunc(b *testing.B)` 形式的的性能测试。那他的目标是什么？是否对其进行独立运行就已经足够了？如果不是，那如何才能正确的进行性能测试？又如何判断我们性能测试得到的结果是可靠的？

benchstat 作为 Go 语言工具链的一环，为我们提供了进行可靠性能测试的必要条件之一。那么 benchstat 又是什么？benchstat 能够为我们做哪些事情？它的基本原理又是什么？有了 benchstat 之后我们就可以「高枕无忧」了吗？我们还需要什么其他的工具吗？

本次分享我们将就上述这些问题展开，讨论如何在 Go 语言中进行可靠的性能测试。

## 大纲

- 准备可靠的测试环境
- benchstat
- 例子与实践
  - 对代码块进行性能调优
  - Benchmark 的正确性分析
  - 其他的影响因素
- benchstat 中假设检验的原理
- 局限性及应对措施

## 分享者自我介绍

欧长坤，Go 夜读 SIG 小组成员

## 分享时间

2020-03-26 21:00:00 UTC+8

## 时间线

- 准备可靠的测试环境 00:00
- benchstat 09:25
- benchstat 原理 24:15
- runtime.memequal 的源码阅读 40:20
- 假设检验的原理 45:50
- 局限于应对措施 perflock 1:07:25
- perflock 原理 1:11:46
- 红黑树 1:24:40
- 手把手教你画出高大尚的图表📈1:28:30
- terminal 吐血分享 1:29:50
- Go map 的一个问题 1:33:50
- 数学的重要性 1:35:00
- Github 案例剖析答疑 1:35:50

## Slides

https://changkun.de/s/gobench/

----

## 观看视频

{{< youtube id="RXM9cDzWZME" >}}
